### clp_ga_selektion.py

from clp_ga_bewertung import bewerte
from random import randint
##from random import seed

### ===== Selektion =====
# Die Individuen im Pool werden so einer Selektion unterworfen, dass
# zunaechst die besten (anteilBeste) ausgewaehlt werden und anschliessend
# der Pool wieder auf die Anzahl aufgefuellt wird, indem
# zufaellige Paare gegeneinander antreten.
def selektion(pool, anzahl, anteilBeste):
    '''0 <= anteilBeste <= 1'''
    if anteilBeste<0 or anteilBeste>1:
            anteilBeste=0.5 # Ersatzwert
    anzahlBeste=round(anzahl*anteilBeste)
    beste=bestimmeBeste(anzahlBeste, pool)
    ##print(len(beste))
##    for element in beste:
##        print(element,bewerte(element))
    ##input((anzahl,anzahlBeste,len(pool)))
    zufaellige=antreten((anzahl-anzahlBeste), pool, beste)
    ##print(zufaellige)
    return beste+zufaellige

### Hilfsfunktion zum Sortieren
# ----- ordne -----
def ordne(elemente):
    def besser(erstes,zweites):
        return bewerte(erstes)>bewerte(zweites)
    def ordneEin(element, sortierte):
        for index in range(len(sortierte)):
            if besser(element, sortierte[index]):
                sortierte.insert(index,element)
                return sortierte
        sortierte[len(sortierte):len(sortierte)]=[element]
        return sortierte
    sortierte=[]
    for element in elemente:
        sortierte=ordneEin(element, sortierte)
    return sortierte

### ----- bestimmeBeste -----
# bestimmt die anzahl besten im Pool
# die Funktion sortiert zunaechst die individuen
# nach ihrer Guete und nimmt die anzahl besten davon
def bestimmeBeste(anzahl, pool):
    sortierte=ordne(pool)
    ##input((anzahl, pool))
    return sortierte[:anzahl]

### ----- antreten -----
# laesst anzahl oft zufaellig ausgewaehlte Individuen gegeneinander
# antreten
def antreten(anzahl, pool, beste):
    if len(pool)<anzahl: print('Fehler')
    ##input(('in antreten, pool:',pool,anzahl,len(pool)))
    zufaellige=[]
    if anzahl==1:
        return [pool[randint(0,len(pool)-1)]]
    for i in range(anzahl):
        index1,index2=randint(0,len(pool)-1),randint(0,len(pool)-1)
        if bewerte(pool[index1])>=bewerte(pool[index2]):
            zufaellige.append(pool[index1])
        else:
            zufaellige.append(pool[index2])
    return zufaellige

### ===== Tests =====
##contListe0=[[0, [40,10,20,30,40,10,80,30,20,30,10]],
##                 [100,[]],[100,[40]],[160,[50]],[60,[50]]]
##contListe1=[[0, [40,10,20,30,40,50,80,30]],
##                 [100,[20]],[100,[40]],[160,[50,30,10]],[60,[10]]]
##contListe2=[[0, [40,10,20,30,40,50,80,30]],
##                 [100,[20,40]],[100,[90]],[160,[50,10]],[60,[60]]]
##contListe3=[[0, [40,20,30,60,50,30]],
##                 [100,[20,40,10]],[100,[90]],[160,[80,50,10]],[60,[40]]]
##pool=[contListe0,contListe1,contListe2,contListe3]
##
####print(pool)
##dieBeste=bestimmeBeste(1,pool)
##print(dieBeste)
##print(dieBeste, bewerte(dieBeste[0]))
##print(antreten(1, pool, dieBeste))
##print(selektion(pool, 3, 0.6))
##print(selektion(pool, 3, 0.2))

